From ee7d3ddf1378f00a9ac6b39c8df3b89fc9a86d33 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Fri, 9 Dec 2022 19:42:50 +0100
Subject: [PATCH] Add missing terminfo entries to our Makefile.

---
 share/terminfo/Makefile.entries | 162 +++++++++++++++++++++++++++++++-
 1 file changed, 161 insertions(+), 1 deletion(-)

diff --git a/share/terminfo/Makefile.entries b/share/terminfo/Makefile.entries
index d013043b4e..6ef32cf330 100644
--- a/share/terminfo/Makefile.entries
+++ b/share/terminfo/Makefile.entries
@@ -3,7 +3,7 @@ LEVEL1=	1 2 3 4 5 6 7 8 9 A E L M N P Q X a b c d e f g h i j k l m n o \
 	p q r s t u v w x z
 
 TERMINFO_ENTRIES=	\
-        1/1178 \
+	1/1178 \
 	1/1730-lm \
 	2/2621 \
 	2/2621-wl \
@@ -123,6 +123,7 @@ TERMINFO_ENTRIES=	\
 	a/act4 \
 	a/act5 \
 	a/addrinfo \
+	a/adds200 \
 	a/adds980 \
 	a/addsviewpoint \
 	a/addsvp60 \
@@ -154,6 +155,9 @@ TERMINFO_ENTRIES=	\
 	a/aj510 \
 	a/aj830 \
 	a/aj832 \
+	a/alacritty \
+	a/alacritty+common \
+	a/alacritty-direct \
 	a/alt2 \
 	a/alt3 \
 	a/alt4 \
@@ -201,6 +205,7 @@ TERMINFO_ENTRIES=	\
 	a/ansi+enq \
 	a/ansi+erase \
 	a/ansi+idc \
+	a/ansi+idc1 \
 	a/ansi+idl \
 	a/ansi+idl1 \
 	a/ansi+inittabs \
@@ -246,6 +251,7 @@ TERMINFO_ENTRIES=	\
 	a/ansis \
 	a/ansis-mono \
 	a/ansisysk \
+	a/ansiterm \
 	a/ansiw \
 	a/ap-vm80 \
 	a/apl \
@@ -754,6 +760,8 @@ TERMINFO_ENTRIES=	\
 	d/dd5000 \
 	d/ddr \
 	d/ddr3180 \
+	d/dec+pp \
+	d/dec+sl \
 	d/dec-vt100 \
 	d/dec-vt220 \
 	d/dec-vt330 \
@@ -828,6 +836,7 @@ TERMINFO_ENTRIES=	\
 	d/dmdt80 \
 	d/dmdt80w \
 	d/dmterm \
+	d/domterm \
 	d/dp3360 \
 	d/dp8242 \
 	d/ds40 \
@@ -844,6 +853,9 @@ TERMINFO_ENTRIES=	\
 	d/dtc382 \
 	d/dtterm \
 	d/dumb \
+	d/dumb-emacs-ansi \
+	d/dvtm \
+	d/dvtm-256color \
 	d/dw \
 	d/dw1 \
 	d/dw2 \
@@ -852,7 +864,10 @@ TERMINFO_ENTRIES=	\
 	d/dwk \
 	d/dwk-vt \
 	e/ecma+color \
+	e/ecma+index \
+	e/ecma+italics \
 	e/ecma+sgr \
+	e/ecma+strikeout \
 	e/elks \
 	e/elks-ansi \
 	e/elks-glasstty \
@@ -894,6 +909,7 @@ TERMINFO_ENTRIES=	\
 	f/f200vi-w \
 	f/falco \
 	f/falco-p \
+	f/fbterm \
 	f/fenix \
 	f/fenixw \
 	f/fixterm \
@@ -915,6 +931,7 @@ TERMINFO_ENTRIES=	\
 	g/gnome+pcfkeys \
 	g/gnome-2007 \
 	g/gnome-2008 \
+	g/gnome-2012 \
 	g/gnome-256color \
 	g/gnome-fc5 \
 	g/gnome-rh62 \
@@ -1103,6 +1120,7 @@ TERMINFO_ENTRIES=	\
 	i/i3164 \
 	i/i400 \
 	i/iTerm.app \
+	i/iTerm2.app \
 	i/ibcs2 \
 	i/ibm+16color \
 	i/ibm+color \
@@ -1179,6 +1197,9 @@ TERMINFO_ENTRIES=	\
 	i/iris-ansi-net \
 	i/iris-color \
 	i/iris40 \
+	i/iterm \
+	i/iterm2 \
+	i/iterm2-direct \
 	j/jaixterm \
 	j/jaixterm-m \
 	j/jerq \
@@ -1191,6 +1212,9 @@ TERMINFO_ENTRIES=	\
 	k/kds7372-w \
 	k/kermit \
 	k/kermit-am \
+	k/kitty \
+	k/kitty+common \
+	k/kitty-direct \
 	k/klone+acs \
 	k/klone+color \
 	k/klone+koi8acs \
@@ -1204,6 +1228,7 @@ TERMINFO_ENTRIES=	\
 	k/konsole-16color \
 	k/konsole-256color \
 	k/konsole-base \
+	k/konsole-direct \
 	k/konsole-linux \
 	k/konsole-solaris \
 	k/konsole-vt100 \
@@ -1230,9 +1255,15 @@ TERMINFO_ENTRIES=	\
 	l/linux-koi8r \
 	l/linux-lat \
 	l/linux-m \
+	l/linux-m1 \
+	l/linux-m1b \
+	l/linux-m2 \
 	l/linux-nic \
 	l/linux-vt \
+	l/linux2.2 \
+	l/linux2.6 \
 	l/linux2.6.26 \
+	l/linux3.0 \
 	l/lisa \
 	l/lisaterm \
 	l/lisaterm-w \
@@ -1248,6 +1279,8 @@ TERMINFO_ENTRIES=	\
 	m/mach \
 	m/mach-bold \
 	m/mach-color \
+	m/mach-gnu \
+	m/mach-gnu-color \
 	m/macintosh \
 	m/macterminal-w \
 	m/mai \
@@ -1285,16 +1318,27 @@ TERMINFO_ENTRIES=	\
 	m/minitel-2 \
 	m/minitel-2-nam \
 	m/minitel1 \
+	m/minitel1-nb \
+	m/minitel12-80 \
 	m/minitel1b \
 	m/minitel1b-80 \
+	m/minitel1b-nb \
+	m/minitel2-80 \
 	m/minix \
 	m/minix-1.5 \
 	m/minix-1.7 \
+	m/minix-3.0 \
 	m/minix-old \
 	m/minix-old-am \
+	m/mintty \
+	m/mintty+common \
+	m/mintty-direct \
 	m/mlterm \
 	m/mlterm+pcfkeys \
 	m/mlterm-256color \
+	m/mlterm-direct \
+	m/mlterm2 \
+	m/mlterm3 \
 	m/mm314 \
 	m/mm340 \
 	m/mod \
@@ -1307,6 +1351,7 @@ TERMINFO_ENTRIES=	\
 	m/mouse-sun \
 	m/mrxvt \
 	m/mrxvt-256color \
+	m/ms-terminal \
 	m/ms-vt-utf8 \
 	m/ms-vt100 \
 	m/ms-vt100+ \
@@ -1323,6 +1368,7 @@ TERMINFO_ENTRIES=	\
 	m/mterm \
 	m/mterm-ansi \
 	m/mvterm \
+	n/n7900 \
 	n/nansi.sys \
 	n/nansi.sysk \
 	n/nansisys \
@@ -1396,6 +1442,7 @@ TERMINFO_ENTRIES=	\
 	n/ndr9500-nl \
 	n/nec \
 	n/nec5520 \
+	n/netbsd6 \
 	n/newhp \
 	n/newhpkeyboard \
 	n/news \
@@ -1438,6 +1485,7 @@ TERMINFO_ENTRIES=	\
 	n/nsterm+mac \
 	n/nsterm+s \
 	n/nsterm-16color \
+	n/nsterm-256color \
 	n/nsterm-7 \
 	n/nsterm-7-c \
 	n/nsterm-7-c-s \
@@ -1451,12 +1499,18 @@ TERMINFO_ENTRIES=	\
 	n/nsterm-acs-m-s \
 	n/nsterm-acs-s \
 	n/nsterm-bce \
+	n/nsterm-build309 \
+	n/nsterm-build326 \
+	n/nsterm-build343 \
+	n/nsterm-build361 \
+	n/nsterm-build400 \
 	n/nsterm-c \
 	n/nsterm-c-7 \
 	n/nsterm-c-acs \
 	n/nsterm-c-s \
 	n/nsterm-c-s-7 \
 	n/nsterm-c-s-acs \
+	n/nsterm-direct \
 	n/nsterm-m \
 	n/nsterm-m-7 \
 	n/nsterm-m-acs \
@@ -1518,6 +1572,7 @@ TERMINFO_ENTRIES=	\
 	o/oconcept \
 	o/ofcons \
 	o/ojerq \
+	o/old-st \
 	o/oldibmpc3 \
 	o/oldpc3 \
 	o/oldsun \
@@ -1597,6 +1652,15 @@ TERMINFO_ENTRIES=	\
 	p/pcansi33 \
 	p/pcansi33m \
 	p/pcansi43 \
+	p/pccon \
+	p/pccon+base \
+	p/pccon+colors \
+	p/pccon+keys \
+	p/pccon+sgr+acs \
+	p/pccon+sgr+acs0 \
+	p/pccon-m \
+	p/pccon0 \
+	p/pccon0-m \
 	p/pccons \
 	p/pcconsole \
 	p/pcix \
@@ -1673,7 +1737,19 @@ TERMINFO_ENTRIES=	\
 	p/pt505-24 \
 	p/pty \
 	p/putty \
+	p/putty+fnkeys \
+	p/putty+fnkeys+esc \
+	p/putty+fnkeys+linux \
+	p/putty+fnkeys+sco \
+	p/putty+fnkeys+vt100 \
+	p/putty+fnkeys+vt400 \
+	p/putty+fnkeys+xterm \
 	p/putty-256color \
+	p/putty-m1 \
+	p/putty-m1b \
+	p/putty-m2 \
+	p/putty-noapp \
+	p/putty-sco \
 	p/putty-vt100 \
 	q/qansi \
 	q/qansi-g \
@@ -1758,6 +1834,7 @@ TERMINFO_ENTRIES=	\
 	s/scoansi-old \
 	s/screen \
 	s/screen+fkeys \
+	s/screen+italics \
 	s/screen-16color \
 	s/screen-16color-bce \
 	s/screen-16color-bce-s \
@@ -1779,35 +1856,65 @@ TERMINFO_ENTRIES=	\
 	s/screen.Eterm \
 	s/screen.gnome \
 	s/screen.konsole \
+	s/screen.konsole-256color \
 	s/screen.linux \
+	s/screen.linux-m1 \
+	s/screen.linux-m1b \
+	s/screen.linux-m2 \
+	s/screen.minitel1 \
+	s/screen.minitel1-nb \
+	s/screen.minitel12-80 \
+	s/screen.minitel1b \
+	s/screen.minitel1b-80 \
+	s/screen.minitel1b-nb \
+	s/screen.minitel2-80 \
 	s/screen.mlterm \
+	s/screen.mlterm-256color \
 	s/screen.mrxvt \
+	s/screen.putty \
+	s/screen.putty-256color \
+	s/screen.putty-m1 \
+	s/screen.putty-m1b \
+	s/screen.putty-m2 \
 	s/screen.rxvt \
 	s/screen.teraterm \
 	s/screen.vte \
+	s/screen.vte-256color \
+	s/screen.xterm-256color \
 	s/screen.xterm-new \
 	s/screen.xterm-r6 \
 	s/screen.xterm-xfree86 \
 	s/screen2 \
 	s/screen3 \
+	s/screen4 \
+	s/screen5 \
 	s/screwpoint \
 	s/scrhp \
 	s/sibo \
+	s/simpleterm \
 	s/simterm \
 	s/soroc \
 	s/soroc120 \
 	s/soroc140 \
 	s/spinwriter \
 	s/st \
+	s/st-0.6 \
+	s/st-0.7 \
+	s/st-0.8 \
 	s/st-16color \
 	s/st-256color \
+	s/st-direct \
 	s/st52 \
 	s/st52-color \
+	s/stterm \
+	s/stterm-16color \
+	s/stterm-256color \
 	s/st52-m \
 	s/st52-old \
 	s/stv52 \
 	s/stv52pc \
 	s/sun \
+	s/sun+sl \
 	s/sun-1 \
 	s/sun-12 \
 	s/sun-17 \
@@ -1892,16 +1999,28 @@ TERMINFO_ENTRIES=	\
 	t/tek4207 \
 	t/tek4207-s \
 	t/tek4404 \
+	t/teken \
 	t/teleray \
 	t/teletec \
 	t/teraterm \
+	t/teraterm-256color \
 	t/teraterm2.3 \
 	t/teraterm4.59 \
+	t/teraterm4.97 \
+	t/terminator \
 	t/terminet \
 	t/terminet1200 \
 	t/terminet300 \
+	t/terminology \
+	t/terminology-0.6.1 \
+	t/terminology-1.0.0 \
+	t/termite \
 	t/tgtelnet \
 	t/ti700 \
+	t/ti703 \
+	t/ti703-w \
+	t/ti707 \
+	t/ti707-w \
 	t/ti733 \
 	t/ti735 \
 	t/ti745 \
@@ -2123,6 +2242,9 @@ TERMINFO_ENTRIES=	\
 	v/vi55 \
 	v/vi550 \
 	v/vi603 \
+	v/viewdata \
+	v/viewdata-o \
+	v/viewdata-rv \
 	v/viewpoint \
 	v/viewpoint3a+ \
 	v/viewpoint60 \
@@ -2145,10 +2267,13 @@ TERMINFO_ENTRIES=	\
 	v/vs100 \
 	v/vs100-x10 \
 	v/vsc \
+	v/vscode \
+	v/vscode-direct \
 	v/vt-61 \
 	v/vt-utf8 \
 	v/vt100 \
 	v/vt100+ \
+	v/vt100+4bsd \
 	v/vt100+enq \
 	v/vt100+fnkeys \
 	v/vt100+keypad \
@@ -2210,6 +2335,7 @@ TERMINFO_ENTRIES=	\
 	v/vt400 \
 	v/vt400-24 \
 	v/vt420 \
+	v/vt420+lrmm \
 	v/vt420f \
 	v/vt420pc \
 	v/vt420pcdos \
@@ -2220,6 +2346,7 @@ TERMINFO_ENTRIES=	\
 	v/vt510pcdos \
 	v/vt52 \
 	v/vt520 \
+	v/vt520ansi \
 	v/vt525 \
 	v/vt61 \
 	v/vt61.5 \
@@ -2227,7 +2354,12 @@ TERMINFO_ENTRIES=	\
 	v/vte+pcfkeys \
 	v/vte-2007 \
 	v/vte-2008 \
+	v/vte-2012 \
+	v/vte-2014 \
+	v/vte-2017 \
+	v/vte-2018 \
 	v/vte-256color \
+	v/vte-direct \
 	v/vtnt \
 	v/vv100 \
 	v/vwmterm \
@@ -2537,10 +2669,20 @@ TERMINFO_ENTRIES=	\
 	x/xtalk \
 	x/xterm \
 	x/xterm+256color \
+	x/xterm+256setaf \
 	x/xterm+88color \
+	x/xterm+alt+title \
+	x/xterm+alt1049 \
 	x/xterm+app \
+	x/xterm+direct \
+	x/xterm+direct2 \
 	x/xterm+edit \
+	x/xterm+indirect \
+	x/xterm+kbs \
+	x/xterm+keypad \
+	x/xterm+noalt \
 	x/xterm+noapp \
+	x/xterm+osc104 \
 	x/xterm+pc+edit \
 	x/xterm+pcc0 \
 	x/xterm+pcc1 \
@@ -2553,9 +2695,20 @@ TERMINFO_ENTRIES=	\
 	x/xterm+r6f2 \
 	x/xterm+sl \
 	x/xterm+sl-twm \
+	x/xterm+sm+1002 \
+	x/xterm+sm+1003 \
+	x/xterm+sm+1005 \
+	x/xterm+sm+1006 \
+	x/xterm+titlestack \
+	x/xterm+tmux \
 	x/xterm+vt+edit \
+	x/xterm+x10mouse \
+	x/xterm+x11hilite \
+	x/xterm+x11mouse \
 	x/xterm-1002 \
 	x/xterm-1003 \
+	x/xterm-1005 \
+	x/xterm-1006 \
 	x/xterm-16color \
 	x/xterm-24 \
 	x/xterm-256color \
@@ -2564,7 +2717,10 @@ TERMINFO_ENTRIES=	\
 	x/xterm-basic \
 	x/xterm-bold \
 	x/xterm-color \
+	x/xterm-direct \
+	x/xterm-direct2 \
 	x/xterm-hp \
+	x/xterm-mono \
 	x/xterm-new \
 	x/xterm-nic \
 	x/xterm-noapp \
@@ -2577,6 +2733,9 @@ TERMINFO_ENTRIES=	\
 	x/xterm-utf8 \
 	x/xterm-vt220 \
 	x/xterm-vt52 \
+	x/xterm-x10mouse \
+	x/xterm-x11hilite \
+	x/xterm-x11mouse \
 	x/xterm-xf86-v32 \
 	x/xterm-xf86-v33 \
 	x/xterm-xf86-v333 \
@@ -2585,6 +2744,7 @@ TERMINFO_ENTRIES=	\
 	x/xterm-xf86-v44 \
 	x/xterm-xfree86 \
 	x/xterm-xi \
+	x/xterm.js \
 	x/xterm1 \
 	x/xtermc \
 	x/xtermm \
-- 
2.37.3